#include <pt.h>
#include <usbdrv.h>
#include "keycodes.h"
#define REPORT_ID_KEYBOARD 1
int JoyStick_X = PIN_PC1; // x
int JoyStick_Z = PIN_PC3; // key
int state = 0;

PROGMEM const char usbHidReportDescriptor[USB_CFG_HID_REPORT_DESCRIPTOR_LENGTH] = 
{
  ///////////////////
  // Keyboard
  ///////////////////
  0x05, 0x01,                    // USAGE_PAGE (Generic Desktop)
  0x09, 0x06,                    // USAGE (Keyboard)
  0xa1, 0x01,                    // COLLECTION (Application)
  0x85, 0x01,                    //   REPORT_ID (1)
  0x05, 0x07,                    //   USAGE_PAGE (Keyboard)
  0x19, 0xe0,                    //   USAGE_MINIMUM (Keyboard LeftControl)
  0x29, 0xe7,                    //   USAGE_MAXIMUM (Keyboard Right GUI)
  0x15, 0x00,                    //   LOGICAL_MINIMUM (0)
  0x25, 0x01,                    //   LOGICAL_MAXIMUM (1)
  0x75, 0x01,                    //   REPORT_SIZE (1)
  0x95, 0x08,                    //   REPORT_COUNT (8)
  0x81, 0x02,                    //   INPUT (Data,Var,Abs)
  0x95, 0x01,                    //   REPORT_COUNT (1)
  0x75, 0x08,                    //   REPORT_SIZE (8)
  0x25, 0x65,                    //   LOGICAL_MAXIMUM (101)
  0x19, 0x00,                    //   USAGE_MINIMUM (Reserved (no event indicated))
  0x29, 0x65,                    //   USAGE_MAXIMUM (Keyboard Application)
  0x81, 0x00,                    //   INPUT (Data,Ary,Abs)
  0xc0,                          // END_COLLECTION
};

struct ReportKeyboard
{
  /* +----\------+-----+-----+-----+-----+-----+-----+-----+-----+
   * |Byte \ Bit |  7  |  6  |  5  |  4  |  3  |  2  |  1  |  0  |
   * +------\----+-----+-----+-----+-----+-----+-----+-----+-----+
   * |  0        |               Report ID = 1                   |
   * +-----------+-----+-----+-----+-----+-----+-----+-----+-----+
   * |  1        |           Modifiers (shift,ctrl,etc)          |
   * +-----------+-----+-----+-----+-----+-----+-----+-----+-----+
   * |  2        |                 Key Code                      |
   * +-----------+-----+-----+-----+-----+-----+-----+-----+-----+
   */
  uint8_t  report_id;
  uint8_t  modifiers;
  uint8_t  key_code;
};

ReportKeyboard reportKeyboard;

usbMsgLen_t usbFunctionSetup(uchar data[8])
{
  usbRequest_t *rq = (usbRequest_t*)data;

  return 0;  /* Return nothing to host for now */
}
void sendKey(uint8_t keycode, uint8_t modifiers)
{
  reportKeyboard.key_code = keycode;
  reportKeyboard.modifiers = modifiers;
  usbSetInterrupt((uchar*)&reportKeyboard, sizeof(reportKeyboard));
}

static uint8_t sequence[] = {
    KEY_UP_ARROW, KEY_DOWN_ARROW, KEY_ESC
    //,KEY_LEFT_ARROW, KEY_RIGHT_ARROW, KEY_M, KEY_W, KEY_S, KEY_A, KEY_D, KEY_SPACE,
};
void loop()
{
  /* LED 
  digitalWrite(PIN_PC0, HIGH);
  delay(500);
  digitalWrite(PIN_PC0, LOW);
  delay(500);
  digitalWrite(PIN_PC1, HIGH);
  delay(500);
  digitalWrite(PIN_PC1, LOW);
  delay(500);
  digitalWrite(PIN_PC2, HIGH);
  delay(500);
  digitalWrite(PIN_PC2, LOW);
  delay(500);
  */
  /* Serial Port
  Serial.println("Hello, Serial");
  delay(500);
  */
  usbPoll();
  // Button
  int x;
  //int y; 
  int z;
  x = analogRead (JoyStick_X);
  //y = analogRead (JoyStick_Y);
  z = digitalRead (JoyStick_Z);
  if((x>950)&&(state==0)){
  digitalWrite(PIN_PC0, HIGH);
  sendKey(sequence[0],0);
  delay(10);
  state=1;
  //digitalWrite(PIN_PC0, LOW);
  //delay(100);
  }
  else if((x<950)&&(state==1)){
  digitalWrite(PIN_PC0, LOW);
  //sendKey(sequence[0],0);
  delay(10);
  state=0;
  }
  else if((x<75)&&(state==0)){
  digitalWrite(PIN_PC2, HIGH);
  sendKey(sequence[1],0);
  delay(10);
  state=1;
  }
  else if((x>75)&&(state==1)){
  digitalWrite(PIN_PC2, LOW);
  //sendKey(sequence[1],0);
  delay(10);
  state=0;
  }
  else if((x>75)&&(x<950)){
    if(z==0){
      sendKey(sequence[2],0);
      delay(100);
      sendKey(KEY_NONE,0);
    }
  digitalWrite(PIN_PC0, LOW);
  sendKey(KEY_NONE,0);
  delay(10);
  digitalWrite(PIN_PC2, LOW);
  sendKey(KEY_NONE,0);
  delay(10); 
  }
  
  Serial.println (x, DEC);
  //Serial.print (",");
  //Serial.println (y, DEC);
  //Serial.print (",");
  Serial.println (z, DEC);
  delay (10);
}
  /*
  if(digitalRead(PIN_PC0)==LOW){
    Serial.println("Top button pressed by player1");
    sendKey(sequence[0],0);
    delay(100);
    sendKey(KEY_NONE,0);
  }
  if(digitalRead(PIN_PC1)==LOW){
    Serial.println("Down button pressed by player1");
    sendKey(sequence[1],0);
    delay(100);
    sendKey(KEY_NONE,0);
  }
  if(digitalRead(PIN_PC2)==LOW){
    Serial.println("Left button pressed by player1");
    sendKey(sequence[2],0);
    delay(100);
    sendKey(KEY_NONE,0);
  }
  if(digitalRead(PIN_PC3)==LOW){
    Serial.println("Right button pressed by player1");
    sendKey(sequence[3],0);
    delay(100);
    sendKey(KEY_NONE,0);
  }
  if(digitalRead(PIN_PC4)==LOW){
    Serial.println("Space button pressed by player1");
    sendKey(sequence[4],0);
    delay(100);
    sendKey(KEY_NONE,0);
  }
  */
  /*if(digitalRead(PIN_PD0)==LOW){
    Serial.println("Top button pressed by player2");
    sendKey(KEY_W,KEY_MOD_LEFT_SHIFT);
    delay(500);
  }
  if(digitalRead(PIN_PD1)==LOW){
    Serial.println("Down button pressed by player2");
    sendKey(KEY_S,KEY_MOD_LEFT_SHIFT);
    delay(500);
  }
  if(digitalRead(PIN_PD2)==LOW){
    Serial.println("Left button pressed by player2");
    sendKey(KEY_A,KEY_MOD_LEFT_SHIFT);
    delay(500);
  }
  if(digitalRead(PIN_PD3)==LOW){
    Serial.println("Right button pressed by player2");
    sendKey(KEY_D,KEY_MOD_LEFT_SHIFT);
    delay(500);
  }
  if(digitalRead(PIN_PD4)==LOW){
    Serial.println("Space button pressed by player2");
    sendKey(KEY_SPACE,KEY_MOD_LEFT_SHIFT);
    delay(500);
  }*/
  
  /* Light
  int light = analogRead(PIN_PC4);
  Serial.println(light);
  delay(500);
  */ 
//}
void setup()
{
  // Initialize USB subsystem
  usbInit();
  usbDeviceDisconnect();
  delay(300);
  usbDeviceConnect();
  
  //player1
  pinMode (JoyStick_X, INPUT);
  pinMode(PIN_PC0, OUTPUT);
  pinMode(PIN_PC2, OUTPUT);
  pinMode (JoyStick_Z, INPUT_PULLUP);
  Serial.begin(9600);
  /*//player2
  pinMode(PIN_PD0, INPUT_PULLUP); //top
  pinMode(PIN_PD1, INPUT_PULLUP); //bottom
  pinMode(PIN_PD2, INPUT_PULLUP); //left
  pinMode(PIN_PD3, INPUT_PULLUP); //right
  pinMode(PIN_PD4, INPUT_PULLUP); //space
  */
  // Initialize USB reports
  reportKeyboard.report_id = REPORT_ID_KEYBOARD;
  reportKeyboard.modifiers = 0;
  reportKeyboard.key_code = KEY_NONE;
}
