#-------------------------------------------------------------------------------
# Name:        module1
# Purpose:
#
# Author:      Pormrapee
#
# Created:     24/11/1472
# Copyright:   (c) Pormrapee 1472
# Licence:     <your licence>
#-------------------------------------------------------------------------------

import pygame as pg
import math
import time
import random
from pygame.locals import *


FPS =50
WINDOW_SIZE = (500,500)
RED = pg.Color('red')
YELLOW = pg.Color('yellow')
BLUE = pg.Color ('blue')
BLACK = pg.Color ('black')
WHITE = pg.Color ('white')
GREY = pg.Color ('grey')
GREEN = pg.Color ('green')
###################################

class Player(object):
    m=2
    v=8
    isjump=0
    def __init__(self, x , y, width=50, thick=50, color=WHITE, speed=5, isjump=False):
        self.width = width
        self.thick = thick
        self.x = x
        self.y = y
        self.color = color
        self.speed = speed
        self.isjump = isjump

    def draw(self, display):
        pg.draw.rect(display, self.color, pg.Rect(
            self.x-self.x,
            self.y - self.width/2.0,
            self.thick,
            self.width), 2)

    def movedown(self):
        self.y+=5

    def jump(self):
        self.isjump = True

    def update(self):
        if self.isjump:
            # Calculate force (F). F = 0.5 * mass * velocity^2.
            if self.v > 0:
                F = ( 0.5 * self.m * (self.v*self.v) )
            else:
                F = -( 0.5 * self.m * (self.v*self.v) )

            # Change position
            self.y = self.y - 0.5*F

            # Change velocity
            self.v = self.v - 0.5

            # If ground is reached, reset variables.
            if self.y >= 220:
                self.y = 220
                self.isjump = False
                self.v = 8
    def hit(self, Donut):
        return (self.x-self.width/2 < Donut.x and self.x+self.width/2 > Donut.x) and (self.y-self.width/2 < Donut.y and self.y+self.width/2 > Donut.y)
    def hit_floor(self,Floor):
        return (self.x-self.width/2 < Floor.x and self.x+self.width/2 > Floor.x) and (self.y-self.width/2 < Floor.y and self.y+self.width/2 > Floor.y)
###################################
class Donut(object):

    def __init__(self, x ,  y, width=10, thick=10, color=YELLOW, speed=10):
        self.width = width
        self.thick = thick
        self.x = 280
        self.y = y
        self.color = color
        self.speed = speed

    def draw(self, display):
        pg.draw.rect(display, self.color, pg.Rect(
            self.x,
            self.y,
            self.thick,
            self.width), 2)

    def move(self):
        self.x -=3

###########################################################
class Floor(object):
    def __init__(self,x=400,y=246,width=5,thick=35,color=RED):
        self.width = width
        self.thick = thick
        self.x = x
        self.y = y
        self.color = color

    def draw(self, display):
        pg.draw.rect(display, self.color, pg.Rect(
            self.x,
            self.y,
            self.thick,
            self.width), 2)

    def move(self):
        self.x -=10
##########################################################
def render_score():
    '''Render score into an image for display'''
    global font,score,score_image
    score_image = font.render("Score = %d" % score, 0, GREY)

def render_stat():
    global font1,stat_image
    stat_image = font1.render("GAME OVER" ,0,GREY)

###########################################################

def main():
    global game_over,font,score,score_image,stat_image,font1

    pg.init()
    clock = pg.time.Clock()
    display = pg.display.set_mode(WINDOW_SIZE)
    pg.display.set_caption('GAME')
    game_over = False
    font = pg.font.SysFont("monospace", 20)
    font1 = pg.font.SysFont("monospace",20)
    score = 0
    score_image = None
    stat =""
    stat_image = None
    donuts = []
    floors = []
    player = Player(color=GREEN,y=220 ,x=15)
    render_score()
    render_stat()
    temp=0
    ###########sound#########
    BUFFER = 3072
    pg.mixer.init()
    FREQ,SIZE,CHAN = pg.mixer.get_init()
    pg.mixer.init(FREQ,SIZE,CHAN,BUFFER)
    filename = '/home/vvilliam/Downloads/Omfg-Hello-mymp3download.wav'
    pg.mixer.init()
    pg.mixer.music.load(filename)
    pg.mixer.music.play()
    ##########################
    while temp<=300:
        floor=Floor(x=player.x+temp,y=246)
        floors.append(floor)
        temp+=40


    while not game_over:

        check_teen_player = False
        for a in floors:
            if(a.x >=0 and a.x<=75):
                check_teen_player=True

        if check_teen_player==False and player.isjump==False:
            render_stat()
            display.blit(stat_image,(10,300)) #draw gameover
            pg.display.update()  # redraw the screen
            time.sleep(2)
            game_over=True

        if not player.isjump:
            if pg.key.get_pressed()[K_UP]:
                player.jump()
        else:
            player.update()
        if pg.key.get_pressed()[K_DOWN]:
            player.width=25

        else:
            player.width=50
        if(random.randint(0,50)>=30):
            donut = Donut(x=player.x, y=random.randint(0,220))
            donuts.append(donut)
        if(random.randint(0,50)>=35):
            for i in range(1,6):
                floor = Floor(x=400,y=246)
                floors.append(floor)

        for event in pg.event.get(): # process events
            if (event.type == QUIT) or \
               (event.type == KEYDOWN and event.key == K_ESCAPE):
                game_over = True

        display.fill(BLACK)  # clear screen
        display.blit(score_image, (10,10)) #draw score

        player.draw(display)  # draw player

        for donut in donuts:
            if donut.y < -10 or donut.y > WINDOW_SIZE[1]+10 or donut.x < -10 or donut.x > WINDOW_SIZE[0]+10:
                donuts.remove(donut)
            donut.move()
            donut.draw(display)
        for floor in floors:
            if floor.y < 0-10 or floor.y > WINDOW_SIZE[1]+10 or floor.x < -10 or floor.x > WINDOW_SIZE[0]+10:
                floors.remove(floor)
            floor.move()
            floor.draw(display)
        for donut in donuts:
            if player.hit(donut):
                donuts.remove(donut)
                score+=5
                render_score()
        stay_on_floor = False
        #for floor in floors:
            #if not player.hit_floor(floor):
               #game_over = True



        pg.display.update()  # redraw the screen
        clock.tick(FPS-21)  # wait to limit FPS requirement
#########################################
if __name__=='__main__':
    main()
    print "Game Over!"
    pg.quit()
